﻿using Connected.Data.Storage;
using Connected.Entities;
using Connected.Entities.Storage;

namespace Connected.Data;
public interface IStorageMiddleware : IQueryProvider, IMiddleware
{
	bool SupportsEntity(Type entityType);
	IStorageOperation CreateOperation<TEntity>(TEntity entity)
		where TEntity : IEntity;

	IStorageReader<TEntity> OpenReader<TEntity>(IStorageOperation operation, IStorageConnection connection);
	IStorageWriter OpenWriter(IStorageOperation operation, IStorageConnection connection);
}
