﻿using Connected.ServiceModel;

namespace Connected.Security.Permissions;

public class PermissionArgs : Dto
{
	public string Evidence { get; init; }
	public string Schema { get; init; }
	public string Claim { get; init; }
	public string? Descriptor { get; init; }
	public string? PrimaryKey { get; init; }
	public string? Entity { get; init; }
	public PermissionValue Value { get; init; }
	public string? Component { get; init; }
	public string? Method { get; init; }
}

public class PermissionUpdateArgs : PrimaryKeyArgs<int>
{
	public PermissionValue Value { get; init; }
}

public class PermissionSearchArgs : Dto
{
	public string? Entity { get; init; }
	public string? Claim { get; init; }
	public string? PrimaryKey { get; init; }
}
